<html>
<!-- License, distribution and documentation will be available from
 http://lcr.math.ist.utl.pt/texdoc-php/ in the not so distant future -->
<head><style type="text/css">
       a:link { color: #0000EE }
       a:visited { color: #001A8B }
       a:active { color: #FF0000 ; background: #ffc}
       h1,h2,h3,h4,h5,h6, table { font-family: helvetica, arial, sans-serif; }
       dt {font-family: courier,monospaced; }
       table { font-size: small;}
       option { font-size:10pt; color:blue; }
       .local {
	 <?php
	     if ($local == "no")
	       {
		 echo "display: none;";
	       }
	     else
	       {
		 echo "
            background: rgb(100,255,255);
            border: none;
            ";
	       }
	   ?>
	     }
       body *:target {color: red;}
</style>
</head>
<body>
<?php

##### New Configuration
### Tree location as relative paths to the current location
### Order is important.
### It is assumed one (and only one) array element has an empty
### key defining the tree where a file not found error will be generated
### by the http daemon in case the file is indeed not found.
### All other trees can be excluded with, e.g.,
### http://www.math.ist.utl.pt/tetexbeta/texmf-dist/doc/texdoc.php?local=no
### http://www.math.ist.utl.pt/tetexbeta/texmf-dist/doc/texdoc.php?dist=no
### End relative paths with slashes /
$texmftrees['fs'] = array( 'dist' => '../../texmf-dist/',
			  '' => '../../texmf/',
			  'local' => '../../texmf-local/' );
$texmftrees['url'] = array( 'dist' => '../../texmf-dist/',
			  '' => '../../texmf/',
			   'local' => '../../texmf-local/');
### It seems natural to give higher precedence to files in the local tree
### but build lists starting with the distribution tree.
$texmftrees2 = array_reverse($texmftrees,TRUE);
################## End of New Configuration

### TODO! Check for a configuration file redefining the trees 
### Changes should make possible to use an arbitrary set of texmf trees

### Detecting the absolute location of this script both 
### in the file system and url space

$ourfs = dirname($_SERVER['SCRIPT_FILENAME']);
$oururl = dirname($_SERVER['PHP_SELF']);

### checklink checks all trees for the file in the given order
### returns $link (a relative URL to the document)

function checklink($relpath)
{
  global $texmftrees2, $ourfs, $oururl;
  reset($texmftrees2['fs']);
  $link = "";
  while (list( $treekey, $treepath) = each($texmftrees2['fs']))
    {
      if ( $_GET[$treekey] <> "no" )
	{
	  $docpath = $ourfs . "/" . $treepath . "doc/";
	  if ( file_exists($docpath . $relpath))
	    {
	      $link = $texmftrees2['url'][$treekey] . "doc/" . $relpath ;
	      break;
	    } 
	  $texpath = $ourfs . "/" . $treepath . "tex/";
	  if ( file_exists($texpath . $relpath))
	    {
	      $link = $texmftrees2['url'][$treekey] . "tex/" . $relpath ;
	      break;
	    }     
	}
    }
  return $link;  
} 

##### Configuration (to be replaced)

#$texdocdat="/usr/local/teTeX/share/texmf-dist/texdoctk/texdoctk.dat";
$texdocdat=$texmftrees['fs']['dist'] . "texdoctk/texdoctk.dat";
#$distdocdir="/usr/local/teTeX/share/texmf-dist/doc/";
$distdocdir=$texmftrees['fs']['dist'] . "doc/";
#$texmf="/usr/local/teTeX/share/texmf/tex/";
$texmf=$texmftrees['fs'][''] ;
#$texmfdist="/usr/local/teTeX/share/texmf-dist/tex/";
$texmfdist=$texmftrees['fs']['dist'] ;
#$docdir="/usr/local/teTeX/share/texmf/doc/";
$docdir=$texmftrees['fs'][''] . "doc/";
#$localdocdir="/usr/local/teTeX/share/texmf-local/doc/";
$localdocdir=$texmftrees['fs']['local'] . "doc/";

##### Parse the texdoc data file
$section=$_GET["section"];
$line=0;

while (list( $treekey, $treepath) = each($texmftrees['fs']))
{
  if ($_GET[$treekey] <> "no")
    {
      $texdocdat=$treepath . "texdoctk/texdoctk.dat";
      if (file_exists($texdocdat))
	{    
	  $row = 0;
	  $handle = fopen ($texdocdat,"r");
	  while ($data[$row] = fgetcsv ($handle, 1000, ";")) 
	    {
	      if ( strpos($data[$row][0],"#") === false )
		{
		  if ( count($data[$row]) == 1 )
		    {
		      $section_name = str_replace("@", "", $data[$row][0]);
		    }
		  else
		    {
		      if ( $section_name==$section)
			{
			  $mydata[$data[$row][0]]["link"] = $data[$row][2];
			  $mydata[$data[$row][0]]["description"] = $data[$row][1];
			  $colorcode = "";
			  $link = checklink($mydata[$data[$row][0]]["link"]);
			  if ($link == "")
			    {
			      $colorcode = " style=\"color:red\" ";
			      $link = $docdir . $mydata[$data[$row][0]]["link"];
			    }
			  $linha[$line]= "<tr><td><a href=\"" . $link . "\" target=\"_blank\"" . $colorcode . ">"  . $mydata[$data[$row][0]]["description"] . "</a></td></tr>\n";
			  $line++;
			}
		    }
		}
	      $row++;
	    }
	  fclose ($handle);
	}
    }
}
echo "<h3>" . $section . "</h3>";
?>

<table>
<?php
$numline= $line;
$line=0;
while ($line < $numline)
{
  echo $linha[$line];
  $line++;
}
?>
</table>
<?php

?>
</body>
</html>